<?
// bitcash2.php

require( 'config.php' );
require( 'lib.php' );

//
$shop_id = '';
$shop_passwd = '';

//
session_start();

//
if ( ( $login = auth() ) == FALSE ) {
	header( 'Location: login.php?redirect=login.php' );
	exit;
}

// db connect
$link = db_connect();

// bitcash カード判定
$sendid = $_POST{"login_id"};
$card_number = $_POST{"card_number"};
$price = $bitcash_point[$_POST{"bitcash_point_menu"}][1];
$sendpoint = $bitcash_point[$_POST{"bitcash_point_menu"}][2];
$mt_host = 'ssl.bitcash.co.jp';
$mt_xmlrpc_path = '/api';

// XMLRPC通信時、送信文字列が日本語の場合、UTF-8に変換する
$card_number = mb_convert_encoding( $_POST['card_number'], 'UTF-8' );
$rating = "19"; // STD=19 EX=99 KIDS=12
$order_id = '';

if ( $card_number <> '' ) {
	$GLOBALS['xmlrpc_defencoding'] = 'UTF-8';
	include( 'xmlrpc.inc' );
	// XML-RPCインタフェース、ユーザ定義
	// 日本語文字列はUTF-8に変換
	// クライアントの作成
	$c = new xmlrpc_client( $mt_xmlrpc_path, $mt_host, https );

	// XMLコード変換
	$shop_id_val = new xmlrpcval( $shop_id, 'string' );
	$shop_passwd_val = new xmlrpcval( $shop_passwd, 'string' );
	$card_number_val = new xmlrpcval( $card_number, 'string' );
	$rating_val = new xmlrpcval( $rating, 'int' );
	$price_val = new xmlrpcval( $price, 'int' );
	$order_id_val = new xmlrpcval( $order_id, 'base64' );

	// 受け渡し用ハッシュ作成
	$struct = new xmlrpcval( array( 'SHOP_ID' => $shop_id_val,
			'SHOP_PASSWD' => $shop_passwd_val,
			'CARD_NUMBER' => $card_number_val,
			'"RATING' => $rating_val,
			'PRICE' => $price_val,
			'ORDER_ID' => $order_id_val ), 'struct' );

	// メッセージ作成
	$message = new xmlrpcmsg(
		'Settlement.validate_card',
		array( $struct )
	);

	// メッセージ送信
	$result = $c->send( $message );
	// ConnectionErrorCheck
	if ( !$result ) {
		exit( 'Could not connect to the server.' );
	} else if ( $result->faultCode() ) {
		exit( 'XML-RPC fault (' . $result->faultCode() . '): ' . $result->faultString() );
	}

	$struct = $result->value();
	$errorval = $struct->structmem( 'ERROR' );
	$error = $errorval->scalarval();

	if ( $error ) {
		echo "カードナンバーが間違っているか<br>ビットキャッシュ残高が足りません<br>\n";
		exit;
	}

	$STATUSval = $struct->structmem( 'STATUS' );
	$STATUS = $STATUSval->scalarval();

	$BCS_IDval = $struct->structmem( 'BCS_ID' );
	$BCS_ID = $BCS_IDval->scalarval();

	$BALANCEval = $struct->structmem( 'BALANCE' );
	$BALANCE = $BALANCEval->scalarval();

	$LOG_IDval = $struct->structmem( 'LOG_ID' );
	$LOG_ID = $LOG_IDval->scalarval();
} else {
	echo 'カードナンバーを入力して下さい';
	exit;
}

//決済処理
if ( $STATUS == 'OK' ) {
	$bcs_id = $BCS_ID; // カード判定の戻り値

	$shop_id_val = new xmlrpcval( $shop_id, 'string' );
	$shop_passwd_val = new xmlrpcval( $shop_passwd, 'string' );
	$order_id_val = new xmlrpcval( $order_id, 'base64' );
	$bcs_id_val = new xmlrpcval( $bcs_id, 'int' );
	$price_val = new xmlrpcval( $price, 'int' );
	$struct = new xmlrpcval( array( 'SHOP_ID' => $shop_id_val,
			'SHOP_PASSWD' => $shop_passwd_val,
			'BCS_ID' => $bcs_id_val,
			'PRICE' => $price_val,
			'ORDER_ID' => $order_id_val ), 'struct' );

	//メッセージ作成
	$message = new xmlrpcmsg(
		'Settlement.do_settlement',
		array( $struct )
	);

	//メッセージ送信
	$result = $c->send( $message );
	if ( !$result ) {
		exit( 'Could not connect to the server.' );
	} else if ( $result->faultCode() ) {
		exit( 'XML-RPC fault (' . $result->faultCode().'): ' . $result->faultString() );
	}

	$struct = $result->value();
	$ERRORval = $struct->structmem( 'ERROR' );
	$ERROR = $ERRORval->scalarval();

	if ( $ERROR ) {
		echo 'ビットキャシュ決済に失敗しました';
		exit;
	}

	$STATUSval = $struct->structmem( 'STATUS' );
	$STATUS = $STATUSval->scalarval();

	$LOG_IDval = $struct->structmem( 'LOG_ID' );
	$LOG_ID = $LOG_IDval->scalarval();

	$BALANCEval = $struct->structmem( 'BALANCE' );
	$BALANCE = $BALANCEval->scalarval();

	$SALES_IDval = $struct->structmem( 'SALES_ID' );
	$SALES_ID = $SALES_IDval->scalarval();
} else {
	echo 'カード判定に失敗しました';
	exit;
}

if ($STATUS == "OK"){
	//
	$date = date( 'Y-m-d H:i:s' );

	// 接続
	$link = mysql_connect( $db_host, $db_user, $db_password );
	mysql_select_db( $db_name );

	$sql = "update users set point = point + $sendpoint, bitcash_num = bitcash_num + 1, bitcash_total = bitcash_total + $price where login_id = '$sendid'";
	$result = mysql_query( $sql );

	//
	$sql = "select * from users where login_id = '$sendid'";
	$result = mysql_query( $sql );
	$users = mysql_fetch_array( $result );

	//
	$sql = "insert into sales (
		serial_id,
		tel,
		sales_type,
		date,
		money,
		point,
		state
	) values (
		'${users['serial_id']}',
		'$tel',
		'4',
		'$date',
		'$price',
		'$sendpoint',
		'0'
	)";

	$result = mysql_query( $sql );

	header( 'Location: bitcash3.php?sendid=' . $sendid . '&sendpoint=' . $sendpoint . '&balance=' . $BALANCE );

} else {
	print ("ビットキャッシュ決済でエラーが発生しました");
	exit;
}

exit;

?>